﻿/*
    Programa: xadez.exe
    Descrição: biblioteca necessária para criação da tela básica do programa e para a inteligação com as demais bibliotecas.
    Programador: Eduardo Prates Albuquerque
    RGM: 21500
    Data da última modificação: 24/09/2016
*/

#include <stdio.h>					/* printf() */
#include <stdlib.h>					/* tem(), sleep()*/
#include <string.h>					/* strcpy() */
#include "xeque.h"                  /* Funções de verificação de Xeque e Xeque Mate*/
#include "arvore.h"                 /* Função que cria a árvore de jogadas*/
#include "func.h" 					/* escopo de funções, Defines*/
#include <windows.h>
#include "conio_v3.2.4.h" 			/* Função clrscr(), gotoxy() */


void menu()
{
EVENTO mouseEvento; /*guarda os dados dos evento ocorrido pelo mouse*/
EVENTO tecladoEvento; /*guarda os dados dos evento ocorrido pelo teclado*/
COORD TelaInicial, posicaoTelaInicial;
int opc=1,valida=0,xeque=2,mate=0; /*Condição que identifica se o jogo acabou ou não*/
int vez=0,lances=0,tmp; /*Identifica qual jogador realiza o movimento, identifica quantos movimentos foram realizados no jogo*/
float avaliacao=0; /*Identifica quem está ganhando de acordo com a avaliação estática*/
int pos_atual=-1,nova_pos,empate=0; /*Posição atual da peça que se deseja mover, posição para a qual se deseja movimentar a peça*/
int x,y, cont_ameaca=0,ameaca=0, nivel_arvore=1; /*Variavel auxiliar para guardar o estado atual do jogo,guarda o nível da árvore*/
int atual_branco=74,atual_preto=4,qtde_lances=0; /*osição atual do rei branco, posição atual do rei preto, quantidades lances no jogo*/
Arvore *aux_arvore=NULL,*arv=NULL; /*Varíável auxiliar, árvore de jogadas*/
Jogada *jog=NULL;   /*Lista ligada que contem as sugestões de jogadas*/

/*Tabuleiro 8x8, onde as peças pares são as brancas e as ímpares são as pretas.
10(peão) 20(bispo) 30(cavalo) 40(torre) 50(rainha) 60(rei)*/
int Mat_Tabuleiro[8][8] = {
    {41, 31, 21, 51, 61, 21, 31, 41},
	{11, 11, 11, 11, 11, 11, 11, 11},
	{00, 00, 00, 00, 00, 00, 00, 00},
	{00, 00, 00, 00, 00, 00, 00, 00},
	{00, 00, 00, 00, 00, 00, 00, 00},
	{00, 00, 00, 00, 00, 00, 00, 00},
	{10, 10, 10, 10, 10, 10, 10, 10},
	{40, 30, 20, 50, 60, 20, 30, 40}
	};

	TelaInicial = tamanhoJanelaConsole(); 		/* Guarda o tamanho inicial da tela do console */
	alterarTamanhoJanela(TelaInicial);			/* Vai checar se o tamanho do console já é o máximo, se for seta o tamanho da janela com os valores fornecidos */
	posicaoTelaInicial = getPosicaoJanela();	/* Captura a localização do console na tela */
	setPosicaoJanela(0, 0); 					/* Cola o console no canto superior esquerdo da tela */
	setCursorStatus(0); 						/* Desliga o cursor piscante no console */

	tabuleiro(Mat_Tabuleiro, DIM, vez); /*Desenha o Tabuleiro*/

	do
	{
		/*EVENTO DO TECLADO*/
		if (hit(KEYBOARD_HIT))
        {
			/*Guarda evento do teclado*/
			tecladoEvento = Evento();

			/* Identificar se ocorreu algum evento do teclado */
			if (tecladoEvento.tipo_evento & KEY_EVENT)
			{
				/* Se for pressionada a tecla ESC, encerrar o programa */
				if (tecladoEvento.teclado.codigo_tecla == ESC)
				{
					opc=0;
				}
			}
		}

        /*EVENTO DO MOUSE*/
        if (hit(MOUSE_HIT))
        {
            /*Guarda evento do mouse*/
            mouseEvento = Evento();
			if (mouseEvento.tipo_evento & MOUSE_EVENT)
			{
				/*Identifica qual peça o jogador deseja mover*/
				if (mouseEvento.mouse.botao_pressionado && FROM_LEFT_1ST_BUTTON_PRESSED && pos_atual==-1)
				{
					pos_atual=ident_peca(mouseEvento.mouse.posicao.X,mouseEvento.mouse.posicao.Y,Mat_Tabuleiro, vez);
				}

				/*Identifica e valida a posição para onde o jogador deseja mover sua peça*/
				else if (mouseEvento.mouse.botao_pressionado && FROM_LEFT_1ST_BUTTON_PRESSED && pos_atual!=-1)
				{
					nova_pos=move_peca(mouseEvento.mouse.posicao.X,mouseEvento.mouse.posicao.Y);
					valida=valida_movimento(pos_atual,nova_pos,Mat_Tabuleiro);

					/*Movimenta a peça, verifica xeque, xeque mate,empate, promoção e resenha tabuleiro*/
					if (nova_pos != -1 && nova_pos != pos_atual && valida == 1)
					{
                        /*Verifica quantos lances foram realizados sem a movimentação de nenhum peão e sem que nenhuma peça fosse eliminada*/
                        qtde_lances=empate_50(Mat_Tabuleiro,pos_atual,nova_pos,qtde_lances);
                        if (qtde_lances >= 50)
                        {
                            opc=0;
                            mate=0;
                            empate=1;
                        }

                        tmp=0;
                        if (Mat_Tabuleiro[nova_pos/10][nova_pos%10] !=0)
                        {
                            tmp=Mat_Tabuleiro[nova_pos/10][nova_pos%10];
                        }
                        /*Como o movimento foi validado, ele altera a posicao da peça na matriz*/
                        Mat_Tabuleiro[nova_pos/10][nova_pos%10]=Mat_Tabuleiro[pos_atual/10][pos_atual%10];
						Mat_Tabuleiro[pos_atual/10][pos_atual%10]=0;

                        /*Caso o rei branco tenha se movimentado, informe a posição atual do rei branco*/
                        if (Mat_Tabuleiro[nova_pos/10][nova_pos%10]==60)
                        {
                            atual_branco=nova_pos;
                        }

                        /*Verifica o empate por 'Rei Afogado'*/
						if (empate == 0)
                        {
                            valida=rei_afogado(Mat_Tabuleiro,1,atual_branco,atual_preto);
                            if (valida == 0)
                            {
                                opc=0;
                                mate=0;
                            }
                        }

						/* verifica Xeque e Xeque Mate*/
                        if (opc != 0)
                        {
                            cont_ameaca=0;
                            /*Verifica se os Reis estao em Xeque. Caso sim, retorna ela pra posicao atual*/
                            for (x=0;x<8;x++)
                            {
                                for (y=0;y<8;y++)
                                {
                                    xeque=verifica_xeque(Mat_Tabuleiro,vez,x,y,atual_branco,atual_preto);
                                    /*Condição em que o movimento do computador não deve ser validado, pois coloca o próprio rei em Xeque*/
                                    if (xeque == -1)
                                    {
                                        x=8;
                                        y=8;
                                        mate= -1;
                                    }
                                    /*Caso de Xeque ao adversário*/
                                    else if (xeque >= 0)
                                    {
                                        empate=1;
                                        ameaca=xeque;
                                        cont_ameaca+= 1;
                                        gotoxy(43,44);
                                        printf("                              				      ");
                                        gotoxy(43,44);
                                        printf("Xeque !");
                                        Sleep(2000);
                                    }
                                }
                            }

                            /*Verifica se o movimento colocou o próprio rei do time em xeque. Caso sim, anula o movimento*/
                            if (mate == -1)
                            {
                                gotoxy(43,45);
                                printf("                              				      ");
                                gotoxy(43,45);
                                printf("Movimento inv%clido! Seu rei est%c em Xeque", 160,160);
                                Sleep(1000);



                                Mat_Tabuleiro[pos_atual/10][pos_atual%10]=Mat_Tabuleiro[nova_pos/10][nova_pos%10];

                                /*Caso o movimento seja inválido e uma peça adversária tivesse sido capturada*/
                                if (tmp !=0)
                                {
                                    Mat_Tabuleiro[nova_pos/10][nova_pos%10]=tmp;
                                }
                                else
                                {
                                    Mat_Tabuleiro[nova_pos/10][nova_pos%10]=0;
                                }
                                mate=0;
                                tmp=0;
                            }
                            /*Se o rei da peça que realizou o movimento não está em xeque*/
                            else
                            {
                                /*Controla a vez de cada jogador de realizar seu movimento. Muda se o movimento for validado*/
                                vez=1;
                                /*Verifica se o peao foi promovido*/
                                if (Mat_Tabuleiro[nova_pos/10][nova_pos%10]==10 && nova_pos/10==0)
                                {
                                    Mat_Tabuleiro[nova_pos/10][nova_pos%10]=50;
                                    gotoxy(43,45);
                                    printf(" Pe%co promovido!\n",198);
                                    Sleep(2500);
                                }

                                /*O movimento colocou o rei adversário em Xeque. Verifica se é mate*/
                                if (cont_ameaca > 0)
                                {
                                    mate=xeque_mate (Mat_Tabuleiro,ameaca,atual_preto,atual_branco,atual_preto);
                                    if (mate == 0)
                                    {
                                        tabuleiro(Mat_Tabuleiro, DIM, vez);
                                        opc=0;
                                        gotoxy(43,45);
                                        printf("Xeque Mate. Time Branco Venceu!");
                                        break;
                                    }
                                    else
                                    {
                                        tabuleiro(Mat_Tabuleiro, DIM, vez);
                                        gotoxy(43,45);
                                        printf("Aguarde! Jogador do time preto analisando jogada...\n");
                                        Sleep(1500);
                                        vez=0;
                                        /*Verifica Defesa do xeque Sacrifício*/
                                        if (mate/10000 == 3)
                                        {
                                            x=mate%10000/100;
                                            y=mate%100;
                                            Mat_Tabuleiro[x/10][x%10]=Mat_Tabuleiro[y/10][y%10];
                                            Mat_Tabuleiro[y/10][y%10]=0;
                                        }
                                        /*Verifica eliminação da ameaça*/
                                        else if (mate/100 == 1)
                                        {
                                            x=ameaca;
                                            Mat_Tabuleiro[x/10][x%10]=Mat_Tabuleiro[mate%100/10][mate%10];
                                            Mat_Tabuleiro[mate%100/10][mate%10]=0;
                                        }
                                        /*Verifica escape do rei*/
                                        else if (mate/100 == 2)
                                        {
                                            x=mate%100;
                                            Mat_Tabuleiro[x/10][x%10]=Mat_Tabuleiro[atual_preto/10][atual_preto%10];
                                            Mat_Tabuleiro[atual_preto/10][atual_preto%10]=0;
                                        }

                                        /*Recupera a posicao atual dos reis*/
                                        for (x=0;x<8;x++)
                                        {
                                            for (y=0;y<8;y++)
                                            {
                                                if (Mat_Tabuleiro[x][y]==60)
                                                {
                                                    atual_branco=x*10+y;
                                                }
                                                else if (Mat_Tabuleiro[x][y]==61)
                                                {
                                                    atual_preto=x*10+y;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }

                        /*Desenha o Tabuleiro*/
                        tabuleiro(Mat_Tabuleiro, DIM, vez);
                        lances+=1;
                        /*JOGADA DAS PEÇAS PRETAS - IA*/
                        if (vez ==1 && opc !=0)
                        {
                            empate=0;
                             /*Primeiro lance das peças pretas*/
                            if (lances+1 <=2)
                            {
                                    jog=verifica_jogada(vez,Mat_Tabuleiro,atual_branco,atual_preto,lances+1);
                                    x=jog->conteudo/100;
                                    y=jog->conteudo%100;
                                    Mat_Tabuleiro[y/10][y%10]=Mat_Tabuleiro[x/10][x%10];
                                    Mat_Tabuleiro[x/10][x%10]=0;
                                    Sleep(1000);
                                    /*Desenha o Tabuleiro*/
                                    vez=0;
                                    tabuleiro(Mat_Tabuleiro, DIM, vez);
                            }

                            /*Demais jogadas*/
                            else
                            {
                                /*Caso não haja empate por rei afogado, gera a árvore de jogadas*/
                                if (opc !=0)
                                {
                                     /*Insere a Raiz da Árvore*/
                                    cria_no(&arv,0,Mat_Tabuleiro,0,0);

                                    gotoxy(43,45);
                                    printf("Aguarde! Jogador do time preto analisando jogada...\n");
                                    aux_arvore=arv;
                                    Imprimir(aux_arvore,atual_branco,atual_preto,lances,nivel_arvore,vez);

                                    avaliacao=minimax(aux_arvore,3,-20000, 20000);

                                    /*Retorna a jogada do time preto*/
                                    x=aux_arvore->f1->jogada;
                                    avaliacao=aux_arvore->f1->avaliacao;
                                    if (aux_arvore->f2 != NULL && aux_arvore->f2->avaliacao > avaliacao){x=aux_arvore->f2->jogada; avaliacao=aux_arvore->f2->jogada;}
                                    if (aux_arvore->f3 != NULL && aux_arvore->f3->avaliacao > avaliacao){x=aux_arvore->f3->jogada; avaliacao=aux_arvore->f3->jogada;}
                                    if (aux_arvore->f4 != NULL && aux_arvore->f4->avaliacao > avaliacao){x=aux_arvore->f4->jogada; avaliacao=aux_arvore->f4->jogada;}
                                    if (aux_arvore->f5 != NULL && aux_arvore->f5->avaliacao > avaliacao){x=aux_arvore->f5->jogada; avaliacao=aux_arvore->f5->jogada;}
                                    if (aux_arvore->f6 != NULL && aux_arvore->f6->avaliacao > avaliacao){x=aux_arvore->f6->jogada; avaliacao=aux_arvore->f6->jogada;}
                                    if (aux_arvore->f7 != NULL && aux_arvore->f7->avaliacao > avaliacao){x=aux_arvore->f7->jogada; avaliacao=aux_arvore->f7->jogada;}
                                    if (aux_arvore->f8 != NULL && aux_arvore->f8->avaliacao > avaliacao){x=aux_arvore->f8->jogada; avaliacao=aux_arvore->f8->jogada;}
                                    if (aux_arvore->f9 != NULL && aux_arvore->f9->avaliacao > avaliacao){x=aux_arvore->f9->jogada; avaliacao=aux_arvore->f9->jogada;}
                                    if (aux_arvore->f10 != NULL && aux_arvore->f10->avaliacao > avaliacao){x=aux_arvore->f10->jogada; avaliacao=aux_arvore->f10->jogada;}
                                    if (aux_arvore->f11 != NULL && aux_arvore->f11->avaliacao > avaliacao){x=aux_arvore->f11->jogada; avaliacao=aux_arvore->f11->jogada;}
                                    if (aux_arvore->f12 != NULL && aux_arvore->f12->avaliacao > avaliacao){x=aux_arvore->f12->jogada; avaliacao=aux_arvore->f12->jogada;}
                                    if (aux_arvore->f13 != NULL && aux_arvore->f13->avaliacao > avaliacao){x=aux_arvore->f13->jogada; avaliacao=aux_arvore->f13->jogada;}
                                    if (aux_arvore->f14 != NULL && aux_arvore->f14->avaliacao > avaliacao){x=aux_arvore->f14->jogada; avaliacao=aux_arvore->f14->jogada;}
                                    if (aux_arvore->f15 != NULL && aux_arvore->f15->avaliacao > avaliacao){x=aux_arvore->f15->jogada; avaliacao=aux_arvore->f15->jogada;}
                                    if (aux_arvore->f16 != NULL && aux_arvore->f16->avaliacao > avaliacao){x=aux_arvore->f16->jogada; avaliacao=aux_arvore->f16->jogada;}
                                    if (aux_arvore->f17 != NULL && aux_arvore->f17->avaliacao > avaliacao){x=aux_arvore->f17->jogada; avaliacao=aux_arvore->f17->jogada;}
                                    if (aux_arvore->f18 != NULL && aux_arvore->f18->avaliacao > avaliacao){x=aux_arvore->f18->jogada; avaliacao=aux_arvore->f18->jogada;}
                                    if (aux_arvore->f19 != NULL && aux_arvore->f19->avaliacao > avaliacao){x=aux_arvore->f19->jogada; avaliacao=aux_arvore->f19->jogada;}
                                    if (aux_arvore->f20 != NULL && aux_arvore->f20->avaliacao > avaliacao){x=aux_arvore->f20->jogada; avaliacao=aux_arvore->f20->jogada;}

                                    /*Verifica quantos lances foram realizados sem a movimentação de nenhum peão e sem que nenhuma peça fosse eliminada*/
                                    qtde_lances=empate_50(Mat_Tabuleiro,x/100,x%100,qtde_lances);
                                    if (qtde_lances >= 50)
                                    {
                                        opc=0;
                                        mate=0;
                                        empate=1;
                                    }

                                    if (opc !=0)
                                    {
                                        Mat_Tabuleiro[x%100/10][x%10]=Mat_Tabuleiro[x/1000][x%1000/100];
                                        Mat_Tabuleiro[x/1000][x%1000/100]=0;
                                        nova_pos=x;

                                         /*Caso o rei preto tenha se movimentado, informe a posição atual dele*/
                                        if (Mat_Tabuleiro[x%100/10][x%10]==61)
                                        {
                                            atual_preto=x%100;
                                        }

                                        /*Redesenha o tabuleiro*/
                                        tabuleiro(Mat_Tabuleiro,DIM,vez);

                                         /*Verifica se o peao foi promovido*/
                                        if (Mat_Tabuleiro[x%100/10][x%10]==11 && x%100/10==7)
                                        {
                                            Mat_Tabuleiro[nova_pos/10][nova_pos%10]=50;
                                            gotoxy(43,45);
                                            printf(" Pe%co promovido !\n",198);
                                            Sleep(2500);
                                        }
                                    }

                                    /*Verifica o empate por 'Rei Afogado'*/
                                    if (opc != 0)
                                    {
                                        valida=rei_afogado(Mat_Tabuleiro,0,atual_branco,atual_preto);
                                        if (valida == 0)
                                        {
                                            opc=0;
                                            mate=0;
                                        }
                                    }

                                    ameaca=0;
                                    /*Verifica Xeque*/
                                    if (opc !=0)
                                    {
                                        for (x=0;x<=7;x++)
                                        {
                                            for (y=0;y<=7;y++)
                                            {
                                                xeque=verifica_xeque(Mat_Tabuleiro,vez,x,y,atual_branco,atual_preto);
                                                /*Condição em que o movimento do computador não deve ser validado, pois coloca o próprio rei em Xeque*/
                                                if (xeque >=0)
                                                {
                                                    ameaca=xeque;
                                                    x=8;
                                                    y=8;
                                                }
                                            }
                                        }
                                    }
                                    /*Altera a vez do jogador*/
                                    vez=0;

                                    if (opc !=0)
                                    {
                                         /*Informa a movimentação das peças pretas*/
                                        gotoxy(43,45);
                                        switch(Mat_Tabuleiro[nova_pos%100/10][nova_pos%10])
                                        {
                                            case 11: printf("Pe%co Preto de ", 198);break;
                                            case 21: printf("Bispo Preto de ");break;
                                            case 31: printf("Cavalo Preto de ");break;
                                            case 41: printf("Torre Preta de ");break;
                                            case 51: printf("Rainha Preta de ");break;
                                            case 61: printf("Rei Preto de ");break;
                                            default: break;
                                        }

                                        switch(nova_pos%1000/100)
                                        {
                                            case 0: printf("A");break;
                                            case 1: printf("B");break;
                                            case 2: printf("C");break;
                                            case 3: printf("D");break;
                                            case 4: printf("E");break;
                                            case 5: printf("F");break;
                                            case 6: printf("G");break;
                                            case 7: printf("H");break;
                                            default: break;
                                        }

                                        printf("%d para ", 8-nova_pos/1000);

                                        switch(nova_pos%10)
                                        {
                                            case 0: printf("A");break;
                                            case 1: printf("B");break;
                                            case 2: printf("C");break;
                                            case 3: printf("D");break;
                                            case 4: printf("E");break;
                                            case 5: printf("F");break;
                                            case 6: printf("G");break;
                                            case 7: printf("H");break;
                                            default: break;
                                        }
                                        printf("%d", 8-nova_pos%100/10);
                                    }

                                    /*O movimento colocou o rei adversário em Xeque. Verifica se é mate*/
                                    if (ameaca != 0)
                                    {
                                        gotoxy(43,44);
                                        printf("                              				      ");
                                        gotoxy(43,44);
                                        printf("Xeque !");
                                        Sleep(3000);
                                        gotoxy(43,44);
                                        printf("                              				      ");
                                        mate=xeque_mate (Mat_Tabuleiro,ameaca,atual_branco,atual_branco,atual_preto);

                                        if (mate == 0)
                                        {
                                            opc=0;
                                            gotoxy(43,45);
                                            printf("                                                    ");
                                            gotoxy(43,45);
                                            printf("Xeque Mate. Time Preto Venceu!");
                                            break;
                                        }
                                    }
                                    /*Destrói árvore*/
                                    arv=Liberar(&aux_arvore);
                                }
                            }
                        }
                        pos_atual=-1;
                    }
                    else
                    {
                        pos_atual=-1;
                    }
                }
            }
        }
    }while (opc==1);
    gotoxy(1,1);
	system("pause");
	setPosicaoJanela(posicaoTelaInicial.X,posicaoTelaInicial.Y); 	/* Retorna o console sua localização incial */
	setCursorStatus(1);												/* Reativa o cursor piscante no console */
	alterarTamanhoJanela(TelaInicial);								/* Retorna o console ao seu tamanho inicial */
	textbackground(0);
    textcolor(7);
}

/* Função responsável por setar o tamanho da janela do console ao iniciar o programa ou ao finalizá-lo. */
void alterarTamanhoJanela(COORD tamanho)
{
	int altura, largura;
	COORD MaxTela, TelaInicial;

	largura=altura=0;
	TelaInicial =tamanhoJanelaConsole();
	MaxTela=MaxDimensaoJanela();
	/* larg == X alt == Y */
	if((TelaInicial.X == MaxTela.X) && (TelaInicial.Y == MaxTela.Y)) /* se o console estiver maximizado, irá restaura-lo ao tamanho anterior */
	{
		largura=tamanho.X;
		altura =tamanho.Y;
		setDimensaoJanela(largura, altura);
	}
	else if ((TelaInicial.X != MaxTela.X) && (TelaInicial.Y != MaxTela.Y)) /* se o console atual for menor que o máximo permitido, irá máximximizar */
	{
		largura=MaxTela.X;
		altura=MaxTela.Y;
		setDimensaoJanela(largura, altura);
	}
}

/*Essa funcao desenha o tabuleito, com cada peca na devida posicao*/
void tabuleiro(int M[][8],int n, int vez)
{
 int I,K,valor;
	textbackground(1);
    clrscr();
    textcolor(14);
	gotoxy(43,1);
	for(I=0; I<=n-1; I++)
	{
        gotoxy(43,I*4+1+10);

        /*Desenha Primeira Linha*/
        if (I ==0)
        {
            printf("%c",201);

            for (K=0;K<72;K++)
            {
                if (K>0 && K%9 ==0 && K<68)
                {
                    printf("%c",203);
                }
                printf("%c",205);
            }
            printf("%c\n",187);
        }

        /*Desenha Demais Linhas*/
        else
        {
            printf("%c",204);
            for (K=0;K<72;K++)
            {
                if (K>0 && K%9 ==0 && K<68)
                {
                    printf("%c",206);
                }
                printf("%c",205);
            }
            printf("%c\n",185);
        }

		gotoxy(43,I*4+2+10);

		for (K=0;K<9;K++)
        {
            printf("%c         ",186);
		}
        printf("\n");
		gotoxy(43,I*4+3+10);

        /*Desenha a linha que imprime as peças*/
        printf("\n");
        gotoxy(43,I*4+3+10);
        for (K=0;K<9;K++)
        {
        valor=M[I][K];
            if (K<8)
            {
                printf("%c",186);
                if (M[I][K]%10 ==1)
                {
                    textcolor(0);
                }
                else
                {
                    textcolor(7);
                }
                switch(valor)
                {
                    case 0: printf("         ");break;
                    case 10: printf("    BP   ");break;
                    case 20: printf("    BB   ");break;
                    case 30: printf("    BC   ");break;
                    case 40: printf("    BT   ");break;
                    case 50: printf("    BD   ");break;
                    case 60: printf("    BR   ");break;
                    case 11: printf("    PP   ");break;
                    case 21: printf("    PB   ");break;
                    case 31: printf("    PC   ");break;
                    case 41: printf("    PT   ");break;
                    case 51: printf("    PD   ");break;
                    case 61: printf("    PR   ");break;
                    default: break;
                }
                    textcolor(14);
            }

            else
            {
                 printf("%c",186);
            }
		}
		printf("\n");
        gotoxy(43,I*4+4+10);
        for (K=0;K<9;K++)
        {
            printf("%c         ",186);
		}

		gotoxy(1,1);

		 gotoxy(43,I*4+5+10);
		 printf("%c",200);
		 for (K=0;K<72;K++)
        {
            if (K>0 && K%9 ==0 && K<68)
            {
                 printf("%c",202);
            }
            printf("%c",205);
		}
		 printf("%c",188);
    }
	printf("\n");

	gotoxy(67,8);
    if (vez == 0)
    {
        printf("Time Branco realiza o movimento !\n");
    }
    else
    {
        printf("Time Preto realiza o movimento  !\n");
    }
    /*Tabela de Informações - Time*/
    gotoxy(5,17);
    printf("%c",201);
    for(I=0; I<=20; I++)
	{
      printf("%c",205);
	}
    printf("%c\n",187);
    gotoxy(5,18);
    printf("%c        Times        %c\n",186,186);
    gotoxy(5,19);

    printf("%c",204);
    for(I=0; I<=20; I++)
	{
      printf("%c",205);
	}
	printf("%c",185);

    gotoxy(5,20);
    printf("%c B - Time Branco     %c\n",186,186);
    gotoxy(5,21);
    printf("%c P - Time Preto      %c\n",186,186);

    gotoxy(5,22);
    printf("%c",200);
    for(I=0; I<=20; I++)
	{
      printf("%c",205);
	}
	printf("%c",188);

    /*Tabela de Informações - Peças*/
    gotoxy(5,25);
    printf("%c",201);
    for(I=0; I<=20; I++)
	{
      printf("%c",205);
	}
    printf("%c\n",187);
    gotoxy(5,26);
    printf("%c        Pe%cas        %c\n",186,135,186);
    gotoxy(5,27);

    printf("%c",204);
    for(I=0; I<=20; I++)
	{
      printf("%c",205);
	}
	printf("%c",185);

    gotoxy(5,28);
    printf("%c T - Torre           %c\n",186,186);
    gotoxy(5,29);
    printf("%c C - Cavalo          %c\n",186,186);
    gotoxy(5,30);
    printf("%c B - Bispo           %c\n",186,186);
    gotoxy(5,31);
    printf("%c D - Dama (Rainha)   %c\n",186,186);
    gotoxy(5,32);
    printf("%c R - Rei             %c\n",186,186);
    gotoxy(5,33);
    printf("%c P - Pe%co            %c\n",186,198,186);

    gotoxy(5,34);
    printf("%c",200);
    for(I=0; I<=20; I++)
	{
      printf("%c",205);
	}
	printf("%c",188);

	gotoxy(43,10);
    for(I=0; I<=7; I++)
	{
         switch(I)
        {
            case 0: printf("      A   ");break;
            case 1: printf("      B   ");break;
            case 2: printf("      C   ");break;
            case 3: printf("      D   ");break;
            case 4: printf("      E   ");break;
            case 5: printf("      F   ");break;
            case 6: printf("      G   ");break;
            case 7: printf("      H   ");break;
            default: break;
        }
	}


    for (K=0;K<=7;K++)
    {
        gotoxy(41,13+K*4);
        printf("%d",8-K);
    }
}



/*Função que identifica qual peça o jogador deseja movimentar, de acordo com o clique do mouse*/
int ident_peca (int x, int y,int M[][8], int vez)
{
int valor;

		if (x > 42 && x<122 && y>10 && y<42 && x%10!=2 && y%4!=2)
		{
            gotoxy(43,45);
			printf("                     	             				  ");
            gotoxy(43,45);
            valor=  M[(y-10)/4][(x-43)/10];

			if (valor == 0)
			{
				printf("Voc%c selecionou uma casa vazia! Selecione uma pe%ca!",136, 135);
				return -1;
			}

			else if ( valor % 10 == vez) {
                printf("Pe%ca a ser movida: ",135);
                switch(valor)
				{
					case 10: printf("Pe%co Branco ", 198);break;
					case 20: printf("Bispo Branco ");break;
					case 30: printf("Cavalo Branco ");break;
					case 40: printf("Torre Branca ");break;
					case 50: printf("Rainha Branca ");break;
					case 60: printf("Rei Branco ");break;
					default: break;
				}
			}

			else
			{
				printf("Voc%c n%co pode selecionar uma pe%ca do oponente!",136, 198, 135);
				return -1;
			}
		}

		else
		{
            gotoxy(43,45);
			printf("                              				      ");
            gotoxy(43,45);

			return -1;
		}

return (((y-10)/4*10)+((x-43)/10));
}

/*Função que move a peça para uma nova posição, de acordo com a seleção do jogador*/
int move_peca (int x, int y)
{
		if (x > 42 && x<122 && y>10 && y<42 && x%10!=2 && y%4!=2)
		{
            gotoxy(43,45);
			printf("                     	             				");
            gotoxy(43,45);
		}
		else
		{
			return -1;
		}
return (((y-10)/4*10)+((x-43)/10));
}

/*Função que valida o movimento da cada tipo de peça*/
int valida_movimento(int atual, int nova,int M[][8])
{
int nova_x,nova_y,atual_x,atual_y,valida=0;
int aux, cont;

nova_x=nova/10;
nova_y=nova%10;
atual_x=atual/10;
atual_y=atual%10;

    if (nova_x < 0 ||nova_y < 0 || nova_x > 7 || nova_x > 7)
    {
        return 0;
    }

	/*Validar movimentação peão branco*/
	if (M[atual_x][atual_y] == 10)
	{
		/*Verifica se a posição para onde se deseja mover está vazia*/
		if (M[nova_x][nova_y] == 0)
		{
			/*Primeira jogada do Peão*/
			if (atual_x == 6 && nova_x >=4 && nova_x <6 && atual_y == nova_y && M[atual_x-1][atual_y] == 0)
			{
				valida=1;
			}

			/*Demais jogadas do Peão*/
			else if (atual_x != 6 && nova_x +1 == atual_x && atual_y == nova_y)
			{
				valida=1;
			}
		}

		else
		{
			/*Valida  o movimento quando o peão vai comer uma peça adversária*/
			if (M[nova_x][nova_y] % 10 == 1 &&  atual_y != nova_y)
			{
				if ((atual_x -1 == nova_x  && atual_y -1 == nova_y)||( atual_x -1 == nova_x && atual_y +1 == nova_y))
				{
					valida=1;

				}
			}
		}
	}

	/*Validar movimentação peão preto*/
	else if (M[atual_x][atual_y] == 11)
	{
		/*Verifica se a posição para onde se deseja mover está vazia*/
		if (M[nova_x][nova_y] == 0)
		{
			/*Valida o primeiro movimento do peão*/
			if (atual_x == 1 && nova_x >=2 && nova_x <4 && atual_y == nova_y && M[atual_x+1][atual_y] == 0)
			{
				valida=1;
			}

			/*Valida os movimento do peão, a partir do segundo movimento*/
			else if (atual_x != 1 && nova_x -1 == atual_x && atual_y == nova_y)
			{
				valida=1;
			}
		}

		else
		{
			/*Valida  o movimento quando o peão vai comer uma peça adversária*/
			if (M[nova_x][nova_y] % 10 == 0 &&  atual_y != nova_y)
			{
				if ((atual_x +1 == nova_x && atual_y +1 == nova_y) || (atual_x +1 == nova_x && atual_y -1 == nova_y))
				{
					valida=1;
				}
			}
		}
	}

	/*Validar movimentação rei*/
	else if (M[atual_x][atual_y] == 60 || M[atual_x][atual_y] == 61)
	{
		/*Valida o movimento na Vertical (Cima ou baixo)*/
		if ((nova_x-atual_x != 0 && nova_x-atual_x < 2 && nova_x-atual_x > 0) || (nova_x-atual_x != 0 && nova_x-atual_x > -2 && nova_x-atual_x < 0))
		{
			/*valida o movimento, caso seja diagonal, vertical e horizonta*/
			if (nova_y-atual_y < 2 && nova_y-atual_y > -2)
			{
				/*Valida caso não haja nenhuma peça no lugar em que se deseja mover*/
				if (M[nova_x][nova_y] == 0){
					valida=1;
				}

				else
				{
					/*Verifica se a peça na nova posição é inimiga ou aliada*/
					if ((M[nova_x][nova_y] %10) != (M[atual_x][atual_y] %10))
					{
						valida=1;
					}
				}
			}
		}

		/*Valida o movimento em Lateral*/
		else if ((nova_y-atual_y != 0 && nova_y-atual_y < 2 && nova_y-atual_y > 0) || (nova_y-atual_y != 0 && nova_y-atual_y > -2 && nova_y-atual_y < 0))
		{
			/*valida o movimento, caso seja diagonal*/
			if (nova_x-atual_x < 2 && nova_x-atual_x > -2)
			{

				/*Valida caso não haja nenhuma peça no lugar em que se deseja mover*/
				if (M[nova_x][nova_y] == 0)
                {
					valida=1;
				}

				else
				{
					/*Verifica se a peça na nova posição é inimiga ou aliada*/
					if ((M[nova_x][nova_y] %10) != (M[atual_x][atual_y] %10))
					{
						valida=1;
					}
				}
			}
		}
	}

	/*Validar movimentação Cavalo*/
	else if (M[atual_x][atual_y] == 30 || M[atual_x][atual_y] == 31)
	{
			if ((nova_x-atual_x==-2 && nova_y-atual_y==1) || (nova_x-atual_x==-2 && nova_y-atual_y==-1) || (nova_x-atual_x==2 && nova_y-atual_y==1)|| (nova_x-atual_x==2 && nova_y-atual_y==-1))
			{
				/*Valida caso não haja nenhuma peça no lugar em que se deseja mover*/
				if (M[nova_x][nova_y] == 0){
					valida=1;
				}

				else
				{
					/*Verifica se a peça na nova posição é inimiga ou aliada*/
					if ((M[nova_x][nova_y] %10) != (M[atual_x][atual_y] %10))
					{
						valida=1;
					}
				}
			}

			else if((nova_x-atual_x==-1 && nova_y-atual_y==2) || (nova_x-atual_x==-1 && nova_y-atual_y==-2) || (nova_x-atual_x==1 && nova_y-atual_y==2)|| (nova_x-atual_x==1 && nova_y-atual_y==-2))
			{
				/*Valida caso não haja nenhuma peça no lugar em que se deseja mover*/
				if (M[nova_x][nova_y] == 0){
					valida=1;
				}

				else
				{
					/*Verifica se a peça na nova posição é inimiga ou aliada*/
					if ((M[nova_x][nova_y] %10) != (M[atual_x][atual_y] %10))
					{
						valida=1;
					}
				}
			}
	}

	/*Validar movimentação Torre*/
	else if (M[atual_x][atual_y] == 40 || M[atual_x][atual_y] == 41)
	{
		/*Movimento para cima*/
		if (atual_y == nova_y && atual_x != nova_x && atual_x > nova_x )
		{
			aux=atual_x-1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux>=nova_x )
			{
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}

				/*Verifica se a peça no caminho é amiga ou inimiga*/
				else if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
				{
					aux-=1;
					break;
				}
                aux-=1;
			}
			if (aux < nova_x)
			{
				valida=1;
			}
		}

		/*Movimento para baixo*/
		else if (atual_y == nova_y && atual_x != nova_x && atual_x < nova_x )
		{
			aux=atual_x+1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux<=nova_x )
			{
				/*Verifica se a peça no caminho é amiga inimiga*/
				if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}

                /*Verifica se a peça no caminho é inimiga*/
				else if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
				{
				    aux+=1;
					break;
				}
				aux+=1;
			}
			if (aux > nova_x)
			{
				valida=1;
			}
		}

        /*Movimento para Direita*/
		else if (atual_y != nova_y && atual_x == nova_x && atual_y < nova_y )
		{
			aux=atual_y+1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux<=nova_y)
			{
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}

				/*Verifica se a peça no caminho é amiga ou inimiga*/
				else if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 != M[atual_x][atual_y] %10)
				{
				    aux+=1;
					break;
				}
            aux+=1;
			}
			if (aux > nova_y)
			{
				valida=1;
			}
		}

		/*Movimento para Esquerda*/
		else if (atual_y != nova_y && atual_x == nova_x && atual_y > nova_y )
		{
			aux=atual_y-1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux>=nova_y)
			{
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				else if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 != M[atual_x][atual_y] %10)
				{
					aux-=1;
					break;
				}
            aux-=1;
			}
			if (aux < nova_y)
			{
				valida=1;
			}
		}
	}

	/*Validar movimentação bispo*/
	else if (M[atual_x][atual_y] == 20 || M[atual_x][atual_y] == 21)
	{
            /*valida o movimento, caso seja diagonal*/
			if (nova_y-atual_y != 0 && nova_x-atual_x != 0)
			{
			    /*Diagonal direita baixo*/
			    if ((nova_x-atual_x)==(nova_y-atual_y) && (nova_y-atual_y > 0))
                {
                    cont=1;
                    aux=atual_x+1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux<=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux+=1;
                            break;
                        }
                    aux+=1;
                    cont+=1;
                    }

                    if (aux > nova_x)
                    {
                        valida=1;
                    }
                }

                   /*Diagonal esquerda cima*/
			    else if ((nova_x-atual_x)==(nova_y-atual_y) && (nova_y-atual_y < 0))
                {
                    cont=-1;
                    aux=atual_x-1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux>=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga inimiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux-=1;
                            break;
                        }
                    aux-=1;
                    cont-=1;
                    }

                    if (aux < nova_x)
                    {
                        valida=1;
                    }
                }

                 /*Diagonal esquerda baixo*/
			    else if ((nova_x-atual_x)==((nova_y-atual_y)*-1) && (nova_x-atual_x > 0))
                {
                    cont=-1;
                    aux=atual_x+1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux<=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga inimiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux+=1;
                            break;
                        }
                    aux+=1;
                    cont-=1;
                    }

                    if (aux > nova_x)
                    {
                        valida=1;
                    }
                }

                 /*Diagonal direita cima*/
			    else if ((nova_x-atual_x)==((nova_y-atual_y)*-1) && (nova_x-atual_x < 0))
                {
                    cont=1;
                    aux=atual_x-1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux>=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga inimiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux-=1;
                            break;
                        }
                    aux-=1;
                    cont+=1;
                    }

                    if (aux < nova_x)
                    {
                        valida=1;
                    }
                }
            }
    }

    /*Validar movimentação Rainha*/
	else if (M[atual_x][atual_y] == 50 || M[atual_x][atual_y] == 51)
	{
		/*Movimento para cima*/
		if (atual_y == nova_y && atual_x != nova_x && atual_x > nova_x )
		{
			aux=atual_x-1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux>=nova_x )
			{
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}

				/*Verifica se a peça no caminho é amiga ou inimiga*/
				else if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
				{
					aux-=1;
					break;
				}
                aux-=1;
			}
			if (aux < nova_x)
			{
				valida=1;
			}
		}

		/*Movimento para baixo*/
		else if (atual_y == nova_y && atual_x != nova_x && atual_x < nova_x )
		{
			aux=atual_x+1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux<=nova_x )
			{
				/*Verifica se a peça no caminho é amiga inimiga*/
				if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}

                /*Verifica se a peça no caminho é inimiga*/
				else if (M[aux][atual_y] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
				{
				    aux+=1;
					break;
				}
				aux+=1;
			}
			if (aux > nova_x)
			{
				valida=1;
			}
		}

        /*Movimento para Direita*/
		else if (atual_y != nova_y && atual_x == nova_x && atual_y < nova_y )
		{
			aux=atual_y+1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux<=nova_y)
			{
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}

				/*Verifica se a peça no caminho é amiga ou inimiga*/
				else if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 != M[atual_x][atual_y] %10)
				{
				    aux+=1;
					break;
				}
            aux+=1;
			}
			if (aux > nova_y)
			{
				valida=1;
			}
		}

		/*Movimento para Esquerda*/
		else if (atual_y != nova_y && atual_x == nova_x && atual_y > nova_y )
		{
			aux=atual_y-1;
			/*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
			while (aux>=nova_y)
			{
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 == M[atual_x][atual_y] %10)
				{
					break;
				}
				/*Verifica se a peça no caminho é amiga ou inimiga*/
				else if (M[atual_x][aux] != 0 && M[nova_x][aux] %10 != M[atual_x][atual_y] %10)
				{
					aux-=1;
					break;
				}
            aux-=1;
			}
			if (aux < nova_y)
			{
				valida=1;
			}
		}

		 /*valida o movimento, caso seja diagonal*/
			if (nova_y-atual_y != 0 && nova_x-atual_x != 0)
			{
			    /*Diagonal direita baixo*/
			    if ((nova_x-atual_x)==(nova_y-atual_y) && (nova_y-atual_y > 0))
                {
                    cont=1;
                    aux=atual_x+1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux<=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux+=1;
                            break;
                        }
                    aux+=1;
                    cont+=1;
                    }

                    if (aux > nova_x)
                    {
                        valida=1;
                    }
                }

                   /*Diagonal esquerda cima*/
			    else if ((nova_x-atual_x)==(nova_y-atual_y) && (nova_y-atual_y < 0))
                {
                    cont=-1;
                    aux=atual_x-1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux>=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga inimiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux-=1;
                            break;
                        }
                    aux-=1;
                    cont-=1;
                    }

                    if (aux < nova_x)
                    {
                        valida=1;
                    }
                }

                 /*Diagonal esquerda baixo*/
			    else if ((nova_x-atual_x)==((nova_y-atual_y)*-1) && (nova_x-atual_x > 0))
                {
                    cont=-1;
                    aux=atual_x+1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux<=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga inimiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux+=1;
                            break;
                        }
                    aux+=1;
                    cont-=1;
                    }

                    if (aux > nova_x)
                    {
                        valida=1;
                    }
                }

                 /*Diagonal direita cima*/
			    else if ((nova_x-atual_x)==((nova_y-atual_y)*-1) && (nova_x-atual_x < 0))
                {
                    cont=1;
                    aux=atual_x-1;
                    /*Controla para que a peça não possa 'pular' uma outra, caso esteja no caminho*/
                    while (aux>=nova_x )
                    {
                        /*Verifica se a peça no caminho é amiga inimiga*/
                        if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 == M[atual_x][atual_y] %10)
                        {
                            break;
                        }

                        /*Verifica se a peça no caminho é inimiga*/
                        else if (M[aux][atual_y+cont] != 0 && M[aux][nova_y] %10 != M[atual_x][atual_y] %10)
                        {
                            aux-=1;
                            break;
                        }
                    aux-=1;
                    cont+=1;
                    }

                    if (aux < nova_x)
                    {
                        valida=1;
                    }
                }
            }
	}

return valida;
}

/*Função que realiza a avaliação de um estado do jogo*/
float avalia (int M[][8])
{
int linha, coluna;
float aval_ppt=0, aval_pbr=0;

	for (linha=0;linha<8;linha++)
	{
		for (coluna=0;coluna<8;coluna++)
		{
			/*Valor para Peões*/
			if (M[linha][coluna] == 10 || M[linha][coluna] == 11)
			{
				if (M[linha][coluna] % 10 == 0)
				{
					aval_pbr +=1;
					/*Verifica se o peão está no centro*/
					if (linha == 3 || linha == 4)
					{
						aval_pbr +=0.2;
					}
				}
				else
				{
					aval_ppt +=1;

					/*Verifica se o peão está no centro*/
					if (linha == 3 || linha == 4)
					{
						aval_ppt +=0.2;
					}
				}
			}

			/*Valor para Bispos e Cavalos*/
			else if (M[linha][coluna] == 20 || M[linha][coluna] == 30 || M[linha][coluna] == 21 || M[linha][coluna] == 31)
			{
				if (M[linha][coluna] % 10 == 0)
				{
					aval_pbr +=3;
				}
				else
				{
					aval_ppt +=3;
				}
			}

			/*Valor para Torres*/
			else if (M[linha][coluna] == 40 || M[linha][coluna] == 41)
			{
				if (M[linha][coluna] % 10 == 0)
				{
					aval_pbr +=5;
				}
				else
				{
					aval_ppt +=5;
				}
			}

			/*Valor para Rainhas*/
			else if (M[linha][coluna] == 50 || M[linha][coluna] == 51)
			{
				if (M[linha][coluna] % 10 == 0)
				{
					aval_pbr +=9;
				}
				else
				{
					aval_ppt +=9;
				}
			}
		}
	}
return aval_ppt-aval_pbr;
}

/*Função que verifica o empate por 'Rei Afogado' */
int rei_afogado (int M[][8],int vez, int atual_branco, int atual_preto)
{
int x, y,valida,guarda=0;
int a,b,e,f,xeque,res=0;

    for (x=0;x<8;x++)
    {
        for (y=0;y<8;y++)
        {
            /*Verifica se há alguma peça do time no tabuleiro*/
            if (M[x][y] != 0 && M[x][y]%10 == vez)
            {
                for (a=0;a<8;a++)
                {
                    for (b=0;b<8;b++)
                    {
                        /*Verifica se o movimento dessa peça é válido*/
                        if ((valida=valida_movimento(x*10+y,a*10+b,M) == 1))
                        {
                            if (M[a][b] !=0)
                            {
                                guarda=M[a][b];
                            }
                            M[a][b]=M[x][y];
                            M[x][y]=0;
                            /*Atualiza a posição do rei*/
                            if (M[a][b] ==60)
                            {
                                atual_branco=a*10+b;
                            }
                            else  if (M[a][b] ==61)
                            {
                                atual_preto=a*10+b;
                            }

                            /*Verifica se a nova posição ainda coloca o rei sob ataque*/
                            for (e=0;e<=7;e++)
                            {
                                for (f=0;f<=7;f++)
                                {
                                    xeque=verifica_xeque(M,vez,e,f,atual_branco,atual_preto);
                                    if (xeque == -1)
                                    {
                                        res=-1;
                                        e=8;
                                        f=8;
                                    }
                                }
                            }
                            M[x][y]=M[a][b];
                            M[a][b]=guarda;
                            guarda=0;

                            if (res !=-1)
                            {
                                return 1;
                            }
                            else
                            {
                                res=0;
                            }
                        }
                    }
                }
            }
        }
    }
    gotoxy(43,45);
    printf("Empate! 'Rei Afogado'.\n");
    Sleep(2500);

return 0;
}

/*Função que verifica o empate por 50 movimentos sem mover o peão e sem captura*/
int empate_50(int M[8][8], int pos_atual, int nova_pos, int qtde_movimentos)
{
    if (M[nova_pos/10][nova_pos%10] == 0 && M[pos_atual/10][pos_atual%10] /10 !=1)
    {
        if  (qtde_movimentos+1 >=50)
        {
            gotoxy(43,45);
            printf("Empate! 50 Movimentos.\n");
            Sleep(3000);
        }

        return qtde_movimentos+1;
    }
return 0;
}

