/*
	Programa: xadrez.exe
    Descrição: header da biblioteca func, onde encontram-se as declarações de funções, defines e informações da bilioteca.
    Programador: Eduardo Prates Albuquerque
    RGM: 21500
    Data da última modificação: 21/09/2016
*/

#ifndef _FUNC_H_
	#define _FUNC__1

	#include "console_v1.5.4.h" 		/* Função tamanhoJanelaConsole() */
	#define DIM 8

	/*****************************************************************************************************************
	  void alterarTamanhoJanela(COORD);
	  Descrição:
		- Altera o tamanho da janela seja para ocupar o máximo da janela ou o tamanho menor.
		- Espera uma parâmetro COORD, quem contenha o novo tamanho da janela.
		- Não tem parâmetro de retorno.
	*****************************************************************************************************************/
	void alterarTamanhoJanela(COORD);
	/***************************************************************************************************************************
	  void menu ();
	  Descrição:
		- Cria a janela do programa e pilota seus dados na tela.
		- Não tem parâmetro de entrada.
		- Não tem parâmetro de retorno.
	*****************************************************************************************************************************/
	void menu ();

	/***************************************************************************************************************************
	  void tabuleiro ();
	  Descrição:
		- Cria o tabuleiro do jogo
		- Primeiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Segundo parâmentro do tipo "int" recebe o tamanho do tabuleiro.
		- Terceiro parâmetro do tipo "int" recebe qual jogador deve jogar
		- Não tem parâmetro de retorno.
	*****************************************************************************************************************************/
	void tabuleiro(int M[][8],int, int);
	/***************************************************************************************************************************
	  int ident_peca ();
	  Descrição:
		- Identifica a peça movimentada através da posição a qual foi clicada.
		- Primeiro parâmentro do tipo "int" recebe coordenada x da posicao em que o mouse foi clicado.
		- Segundo parâmentro do tipo "int" recebe coordenada y da posicao em que o mouse foi clicado.
		- Terceiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Identifica qual jogador pode movimentar a peça
		- Retorna a posição da movimento realizado
	*****************************************************************************************************************************/
	int ident_peca(int x,int y,int M[][8], int );

	/***************************************************************************************************************************
	  int move_peca ();
	  Descrição:
		- Identifica a posicao para onde a peça será movimentada e a movimenta.
		- Primeiro parâmentro do tipo "int" recebe coordenada x da posicao em que o mouse foi clicado.
		- Segundo parâmentro do tipo "int" recebe coordenada y da posicao em que o mouse foi clicado.
		- Terceiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Retorna a posição da movimento realizado
	*****************************************************************************************************************************/
	int move_peca(int,int);

	/***************************************************************************************************************************
	  int move_peca ();
	  Descrição:
		- Identifica a posicao para onde a peça será movimentada e a movimenta.
		- Primeiro parâmentro do tipo "int" recebe a posição atual da peça que se deseja mover.
		- Segundo parâmentro do tipo "int" recebe a posição para onde se deseja mover a peça.
		- Terceiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Retorna a posição da movimento realizado
	*****************************************************************************************************************************/
	int valida_movimento(int,int,int M[][8]);

    /***************************************************************************************************************************
	  float avalia ();
	  Descrição:
		- Realiza a avaliação estática do jogo.
		- Primeiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Retorna o valor da avaliação
	*****************************************************************************************************************************/
	float avalia(int M[][8]);

    /***************************************************************************************************************************
	  int rei_afogado ();
	  Descrição:
		- Identifica se houve empate por 'Rei Afogado'
		- Primeiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Seguno parâmentro do tipo "int" recebe qual jogador realizará a jogada
        - Terceiro parâmentro do tipo "int" recebe a posicao atual do rei branco.
        - Quarto parâmentro do tipo "int" recebe a posicao atual do rei preto.
        - Retorna o valor da análise se houve ou não empate.
    *****************************************************************************************************************************/
    int rei_afogado(int M[][8],int,int, int);

    /***************************************************************************************************************************
	  int empate_50 ();
	  Descrição:
		- Identifica se houve empate por 50 movimentos
		- Primeiro parâmentro do tipo "int" recebe a matriz das posições do tabuleiro.
		- Seguno parâmentro do tipo "int" recebe a posição atual da peça a ser movimentada
        - Terceiro parâmentro do tipo "int" recebe a posicao a qual se deseja movimentar a peça.
        - Quarto parâmentro do tipo "int" recebe a quantidade atual de movimentos de captura e movimentação de peões.
        - Retorna a quantidade de movimentos atualizada.
    *****************************************************************************************************************************/
    int empate_50(int M[][8],int,int, int);


#endif /* _FUNC_H_ */

